c  ====================================================================
      subroutine edeval(n,fs,t,ed,nq,nd,mapder)
c     .. Real/..
      implicit real (a-h,o-z)
c     .. Array arguments ..
      dimension ed(n,n,*),mapder(nq,nd)
c     .. User-supplied subroutine ..
      external fs
c     .. 
c
c  Purpose
c  =======
c
c  Evaluates exact derivatives of exact solution using function
c  
c	fs(x,y,t,id,jq)
c
c  which gives id'th derivative of jq'th component of fs,
c  evaluated at (x,y,t). Results are stored in array
c
c       ed(ix,iy,jd)
c
c  where id, jq and jd are related by the following loop:
c
c       jd=0
c       do jq=1,nq
c          do id=1,nd
c             Check if derivative id of component jq appears in any equation. 
c             lderiv=.false.
c             do iq=1,nq
c                if(mapcf(iq,jq,id).gt.0)lderiv=.true.
c             end do
c             if(lderiv)then
c                jd=jd+1
c                Now store jd in mapder.
c                mapder(jq,id)=jd
c             end if
c          end do
c       end do
c
c  The indices jd are stored in mapder(jq,id) during the first call to eqn_abc.
c
c  Other Routines Called 
c  =====================
c
c  fs
c
c  ====================================================================
c
c  .. Executable Statements ..
c
      h=1.0/float(n)
c     Loop over components of fs.
      do jq=1,nq
c        Loop over derivatives of each component.
         do id=1,nd
c           Address flag for derivative storage.
            jd=mapder(jq,id)
            if(jd.gt.0)then
	       do i2=1,n
                  x2=i2*h
	          do i1=1,n
                     x1=i1*h
	             ed(i1,i2,jd)=fs(x1,x2,t,id,jq)
                  end do
               end do
            end if
         end do
      end do
      return
      end
