      subroutine eqneval(n,u,a,b,t,as,fs,isol,eqn,
     >    vcoef,nq,nd,mapcf,mapder,fv,ev,nrw,rwk)
      implicit real (a-h,o-z)
      dimension vcoef(n,n,*),u(n,n,*),fv(n,n,nq),ev(n,n,nq),
     > mapder(nq,nd),rwk(nrw),mapcf(nq,nq,nd)
      external as,fs,eqn

      h=1.0/float(n)

c     Compute total number of derivatives stored.
      nder=0
c     Loop over components of fs.
      do 110 jq=1,nq
c        Loop over derivatives of each component.
         do 120 id=1,nd
               if(mapder(jq,id).gt.0)nder=nder+1
120      continue
110   continue
c     Now nder is the total number of derivatives stored.

      if(isol.lt.0)then
c        Evaluate exact solution fs and derivatives and store in rwk.
         call edeval(n,fs,t,rwk,nq,nd,mapder)

c        Evaluate F(fs) and a*I+b*DF(fs) (though we don't need the latter)
c        using values and derivatives of exact solution stored in rwk,
c        and store in ev and vcoef.
c        Coefficients are given by function as, declared external.
         call eqn(n,rwk,a,b,t,as,ev,vcoef,nq,nd,mapcf,mapder)

c        Calculate rhs correction e_t-ev with exact sol'n e=fs.
c        This will make fs the exact solution of the problem.
         do 100 iq=1,nq
         do 100 i2=1,n
            x2=i2*h
         do 100 i1=1,n
            x1=i1*h
            ev(i1,i2,iq)=fs(x1,x2,t,0,iq)-ev(i1,i2,iq)
100      continue
      end if
         
c     Evaluate spectral derivatives of components of u and store in vcoef,
c     using rwk as workspace.
      call udeval(n,u,vcoef,nrw,rwk,nq,nd,mapder)
c     Copy derivatives from vcoef to rwk.
      call scopy(nder*n*n,vcoef,1,rwk,1)
      
c     Evaluate F(u) and a*I+b*DF(u) using values and derivatives 
c     of u stored in rwk, and store in fv and vcoef.
c     Coefficients are given by function as, declared external.
      call eqn(n,rwk,a,b,t,as,fv,vcoef,nq,nd,mapcf,mapder)

      if(isol.lt.0)then
c        Add ev to F=fv and store in fv to make fs a solution.
c        (note saxpy(n,a,x,incx,y,incy) does y <- ax+y)
         call saxpy(n*n*nq,1.0,ev,1,fv,1)
      end if
      

      return
      end
