c  ====================================================================
      subroutine init_grid(n,nq,e,t,fs,ider)
c     .. Real/..
      implicit real (a-h,o-z)
c     .. Array arguments ..
      dimension e(n,n,nq)
c     .. User-supplied subroutine ..
      external fs
c     .. 
c
c  Purpose
c  =======
c
c  init_grid evaluates the derivative number ider of a vector function 
c  fs(x,y,t) with nq components
c  on a square grid with n**2 points
c  (x=i*h,y=j*h), h=1/n, i,j=1,2,...,n, on the unit square [0,1]^2.
c
c  Other Routines Called 
c  =====================
c
c  fs
c
c  ====================================================================
c
c  .. Executable Statements ..
c
      h=1.0/float(n)
      do jq=1,nq
         do i2=1,n
            x2=i2*h
            do i1=1,n
               x1=i1*h
	       e(i1,i2,jq)=fs(x1,x2,t,ider,jq)
            end do
         end do
      end do

      return
      end
