      subroutine init_rfs(n,nq,u,rwk,nrw)
c     .. Real/..
      implicit real (a-h,o-z)
c     .. Arrays ..
      dimension u(n,n,nq),rwk(nrw)
c     .. Common block for solution parameters ..
      common/sol/kt,kx,ky,nsol,psol(100)

c     Make sure we have enough workspace.
      ndwk=4*(kx+1)*(ky+1)+2*(kx+1)+2*(ky+1)
      if(ndwk.gt.nrw)then
         write(6,*) ' not enough workspace in init_rfs'
         write(6,*) ' need ',ndwk,' got ',nrw
         return
      end if

c     Compute and evaluate nq different random Fourier series.
      idum=-1
      ffggbb=ran1(idum)
      h=1.0/float(n)
      tpi=2.0*3.1415926535898
      tph=tpi*h
      do iq=1,nq
c        Generate coefficients.
         iad=0
         do iy=0,ky
            do ix=0,kx
               do ic=0,1
                  do is=0,1
                     iad=iad+1
                     rwk(iad)=2.0*ran1(idum)-1.0
                  end do
               end do
            end do
         end do
c        Done with coefficients: nad is beginning of workspace.
         nad=iad+1

c        Evaluate.
c        Loop over grid points.
         do iy=1,n
            y=iy*h
            do ix=1,n
               x=ix*h
c              Evaluate cosines and sines and store in rwk.
c              Beginning of workspace.
               iad=nad
c              Beginning of storage for cosines and sines of x.
               nadx=iad
               do jx=0,kx
                  iad=iad+1
                  rwk(iad)=cos(jx*tpi*x)
                  iad=iad+1
                  rwk(iad)=sin(jx*tpi*x)
               end do
               nady=iad
               do jy=0,ky
                  iad=iad+1
                  rwk(iad)=cos(jy*tpi*y)
                  iad=iad+1
                  rwk(iad)=sin(jy*tpi*y)
               end do
c              Sum up Fourier cosine series with coeffs from rwk.
               sum=0.0
               iad=0
               do jy=0,ky
c                 Retrieve sines and cosines of y.
                  cy=rwk(nady+2*jy+1)
                  sy=rwk(nady+2*jy+2)
                  do jx=0,kx
c                    Retrieve sines and cosines of x.
                     cx=rwk(nadx+2*jx+1)
                     sx=rwk(nadx+2*jx+2)
c                    Increment sum with sines times cosines etc.
                     iad=iad+1
                     sum=sum+rwk(iad)*cx*cy
                     iad=iad+1
                     sum=sum+rwk(iad)*cx*sy
                     iad=iad+1
                     sum=sum+rwk(iad)*sx*cy
                     iad=iad+1
                     sum=sum+rwk(iad)*sx*sy
                  end do
               end do
c              Store sum in u.
               u(ix,iy,iq)=sum
            end do
         end do

c        Compute max and min of u.
         umx=u(1,1,iq)
         umn=u(1,1,iq)
         do iy=1,n
            do ix=1,n
               umx=max(u(ix,iy,iq),umx)
               umn=min(u(ix,iy,iq),umn)
            end do
         end do

c        Desired min and max values from common block 'sol'.
         pmn=psol(4*(iq-1)+1)
         pmx=psol(4*(iq-1)+2)
         scale=(pmx-pmn)/(umx-umn)
         do iy=1,n
            do ix=1,n
               u(ix,iy,iq)=pmn+scale*(u(ix,iy,iq)-umn)
            end do
         end do

      end do
      return
      end

