      subroutine init_wcr(n,nq,u,rwk,nrw)
c     .. Real/..
      implicit real (a-h,o-z)
c     .. Arrays ..
      dimension u(n,n,nq),rwk(*)
c     .. Common block for solution parameters ..
      common/sol/kt,kx,ky,nsol,psol(100)


c    Input parameters look like this.
ccc  ee		rr	c1	c2	pin	pout	cin	cout	psol 
ccc  0.1	0.2	0.40	0.60	0.48	0.52	0.0	1.0
      ee = psol(1)
      rr = psol(2)
      c1 = psol(3)
      c2 = psol(4)
c     Mesh size.
      h=1.0/float(n)
c     Loop through components of solution.
      do iq=1,nq

c        Unpack internal and external values of solution component from psol.
         pin = psol(2 * (iq - 1) + 5)
         pex = psol(2 * (iq - 1) + 6)
c        Average and difference.
         pav = 0.50 * (pex + pin)
         pdf = 0.50 * (pex - pin)

c        Evaluate circle tanh on grid.
         do i1 = 1,n
            x1 = i1  * h
            do i2 = 1,n
               x2 = i2 * h
               rd = sqrt((x1 - c1)**2 + (x2 - c2)**2) - rr
               u(i1,i2,iq) = pav + pdf * tanh(rd / ee)
            end do
         end do

      end do
      return
      end

