      subroutine init_wsq(n,nq,u,rwk,nrw)
c     .. Real/..
      implicit real (a-h,o-z)
c     .. Arrays ..
      dimension u(n,n,nq),rwk(*)
c     .. Common block for solution parameters ..
      common/sol/kt,kx,ky,nsol,psol(100)


c    Input parameters look like this.
ccc  e1		e2	r1	r2	c1	c2	a1	a2	psol 
ccc  0.1	0.2	0.40	0.60	0.48	0.52	0.0	1.0
ccc  pin	pex	cin	cex
ccc  1.0	0.0	0.0	1.0
c     Epsilon in directions 1 and 2.
      e1 = psol(1)
      e2 = psol(2)
c     Rectangle half-length in directions 1 and 2.
      r1 = psol(3)
      r2 = psol(4)
c     Rectangle center coordinates 1 and 2.
      c1 = psol(5)
      c2 = psol(6)
c     Angle of rotation in radians (a2 is dummy for now).
      a1 = psol(7)
      a2 = psol(8)
      cc = cos(a1)
      ss = sin(a1)
c     Mesh size.
      h=1.0/float(n)
c     Loop through components of solution.
      do iq=1,nq

c        Unpack internal and external values of solution component from psol.
         pin = psol(2 * (iq - 1) +  9)
         pex = psol(2 * (iq - 1) + 10)
c        Difference.
         pdf = pin - pex

c        Evaluate circle tanh on grid.
         do i1 = 1,n
            x1 = i1  * h
            do i2 = 1,n
               x2 = i2 * h
c              Rotate (x1 - c1, x2 - c2) by theta here.
               y1 =  cc * (x1 - c1) + ss * (x2 - c2)
               y2 = -ss * (x1 - c1) + cc * (x2 - c2)
               b1 = r1 - abs(y1)
               b2 = r2 - abs(y2)
               u(i1,i2,iq) = pex + pdf
     >                     * (0.50 + 0.50 * tanh(b1 / e1))
     >                     * (0.50 + 0.50 * tanh(b2 / e2))
            end do
         end do

      end do
      return
      end

