      subroutine initisol(io1,io2,isol,nx,nq,u,t1,fs,rwk,lrw)
c     .. Initial data (exact solution if isol<0) ..
      external fs
c     ..  Work arrays ..
      dimension u(*),rwk(*)
      if(isol.le.0)then
c        u=exp(cosine).
         call init_grid(nx,nq,u,t1,fs,6)
      else if(isol.eq.1)then
c        u=random grid values.
         call init_ran(nx,nq,u,rwk,lrw)
      else if(isol.eq.2)then
c        Initialize u = random kx by kx Fourier series.
         call init_rfs(nx,nq,u,rwk,lrw)
      else if(isol.eq.3)then
c        Initialize u = regular kx by kx Gaussian sum.
         call init_gsg(nx,nq,u,rwk,lrw)
      else if(isol.eq.4)then
c        Initialize u = random Gaussian sum.
         call init_gsr(nx,nq,u,rwk,lrw)
      else if(isol.eq.5)then
c        Initialize u = smoothed circle.
         call init_wcr(nx,nq,u,rwk,lrw)
      else if(isol.eq.6)then
c        Initialize u = smoothed square.
         call init_wsq(nx,nq,u,rwk,lrw)
      else
         write(io1,*) ' Invalid isol= ',isol,' in init_isol'
         write(io2,*) ' Invalid isol= ',isol,' in init_isol'
         stop
      end if
      return
      end

