
      subroutine mapsol(ieqn,isol,n,jq,u,v)
c     Applies user-specified transformation to component jq of u
c     and stores the result in v.

      dimension u(n,n,*), v(n,n,*)

c     .. Number of eqns and vars; must match as.f and mapsol.f!! ..
      parameter(mq=2)

c     .. Maximum size of Fourier series; must match as.f and mapsol.f!! ..
      parameter(mm=51)

c     .. Common block for equation and coefficient parameters ..
      common/eqn/mt,mx,my,neqn,peqn(100),
     >  acoef(0:mm,0:mm,0:mm,mq,mq,6),
     >  tmpt(0:mm),tmpx(0:mm),tmpy(0:mm)

c     .. Common block for solution parameters ..
      common/sol/kt,kx,ky,nsol,psol(100)

c     Start by copying component jq of u into v.
      do i=1,n
         do j=1,n
            v(i,j,jq)=u(i,j,jq)
         end do
      end do

      if(ieqn.eq.22)then
         if(jq.eq.1)then
c           Map Soner z-variable: phi = tanh(z/ee).
            ee = peqn(1)
            do i=1,n
               do j=1,n
                  v(i,j,jq)=tanh(v(i,j,jq)/ee)
               end do
            end do
         end if
      end if

      return
      end

      subroutine unmapsol(ieqn,isol,n,jq,v,u)
c     Applies user-specified inverse transformation to component jq of v
c     and stores the result in u.

      dimension u(n,n,*), v(n,n,*)

c     .. Number of eqns and vars; must match as.f and mapsol.f!! ..
      parameter(mq=2)

c     .. Maximum size of Fourier series; must match as.f and mapsol.f!! ..
      parameter(mm=51)

c     .. Common block for equation and coefficient parameters ..
      common/eqn/mt,mx,my,neqn,peqn(100),
     >  acoef(0:mm,0:mm,0:mm,mq,mq,6),
     >  tmpt(0:mm),tmpx(0:mm),tmpy(0:mm)

c     .. Common block for solution parameters ..
      common/sol/kt,kx,ky,nsol,psol(100)

c     Start by copying component jq of v into u.
      do i=1,n
         do j=1,n
            u(i,j,jq)=v(i,j,jq)
         end do
      end do

      if(ieqn.eq.22)then
         if(jq.eq.1)then
c           Unmap Soner z-variable: phi = tanh(z/ee) => z = ee * atanh(phi).
            ee = peqn(1)
c           Don't let atanh blow up because argument exceeds 1.
            bound = 1.0 - 1.e-16
            if(bound .ge. 1.0)bound = 1.0 - 1.e-14
            if(bound .ge. 1.0)bound = 1.0 - 1.e-12
            if(bound .ge. 1.0)bound = 1.0 - 1.e-10
            if(bound .ge. 1.0)bound = 1.0 - 1.e-08
            if(bound .ge. 1.0)bound = 1.0 - 1.e-06
            if(bound .ge. 1.0)bound = 1.0 - 1.e-04
            do i=1,n
               do j=1,n
                  u(i,j,jq)=ee*atanh(min(bound,max(-bound,u(i,j,jq))))
               end do
            end do
         end if
      end if

      return
      end
