#! /bin/csh -f
#csh command for making ps files into latex pages,
# (nrows * ncols)  at a time.

#Query user for parameters.
#Assume input files have the form [filename]123.ps.
#
#Prefix of input files.
echo '% Enter filename prefix' >/dev/tty
set filename = $<
echo "% filename= $filename"  >$filename.tex
echo "% filename= $filename" >/dev/tty
#
#First input file number.
echo '% Enter first file number ' >/dev/tty
set ifile = $<
echo "% ifile= $ifile"  >>$filename.tex
echo "% ifile= $ifile"  >/dev/tty
#
#Number of input files.
echo '% Enter number of input files' >/dev/tty
set nfile = $<
echo "% nfile= $nfile"  >>$filename.tex
echo "% nfile= $nfile"  >/dev/tty
#Stop at file number iend.
@ ifile = $ifile - 1
@ iend = $ifile + $nfile
#
#Number of rows per page
echo '% Enter number of rows' >/dev/tty
set nrows = $<
echo "% nrows= $nrows"  >>$filename.tex
echo "% nrows= $nrows"  >/dev/tty
#
#Number of columns per page
echo '% Enter number of columns' >/dev/tty
set ncols = $<
echo "% ncols= $ncols"  >>$filename.tex
echo "% ncols= $ncols"  >/dev/tty

#Set number of pages.
@ npages = $nfile / ( $nrows * $ncols )
echo "% npages= $npages"  >>$filename.tex
echo "% npages= $npages"  >/dev/tty
#
#Query user for picture height, width, spacing and offset.
echo '% Enter height of each figure in format 4.0in' >/dev/tty
set height = $<
echo "% height= $height"  >>$filename.tex
echo "% height= $height"  >/dev/tty
echo '% Enter width of each figure in format 3.0in' >/dev/tty
set width = $<
echo "% width= $width"  >>$filename.tex
echo "% width= $width"  >/dev/tty
echo '% Enter vertical spacing between figures in format 0.5in' >/dev/tty
set spacing = $<
echo "% spacing= $spacing"  >>$filename.tex
echo "% spacing= $spacing"  >/dev/tty
echo '% Enter offset at top of page in format -1.0in' >/dev/tty
set offset = $<
echo "% offset= $offset"  >>$filename.tex
echo "% offset= $offset"  >/dev/tty

#Current page number counter
set ipage = 0

echo ' \documentclass{article} '  >>$filename.tex
echo ' \usepackage{psfig} '  >>$filename.tex
echo ' \psfull '  >>$filename.tex
echo ' \pagestyle{myheadings} '  >>$filename.tex
echo ' \markright{'$filename.tex `date`'}'  >>$filename.tex
echo ' \begin{document} '  >>$filename.tex

while ( $ipage < $npages)
   @ ipage = $ipage + 1
   echo "%"  >>$filename.tex
   echo "% Processing page $ipage"  >>$filename.tex
   echo "%"  >>$filename.tex
   echo ' \begin{figure}[p] '  >>$filename.tex
   echo ' \vspace{'$offset'}'   >>$filename.tex

   set irows = 0
   while ( $irows < $nrows)
      @ irows = $irows + 1
      echo '\vspace{'$spacing'}'   >>$filename.tex
      echo '\centerline{'   >>$filename.tex

      set icols = 0
      while ( $icols < $ncols)
         @ icols = $icols + 1
         @ ifile = $ifile + 1
	 if( $ifile > $iend)then
	    break;break;break
	 else
            echo "\psfig{file=$filename.$ifile.ps,height=$height,width=$width}"   >>$filename.tex
	 endif
      end

      echo '}'   >>$filename.tex
   end

   echo '\end{figure}'  >>$filename.tex
   echo '\clearpage'  >>$filename.tex
   echo "%"  >>$filename.tex
   echo "%"  >>$filename.tex

end

echo '\end{document}'   >>$filename.tex
