c  ====================================================================
      subroutine udeval(n,u,ud,nrw,zd,nq,nd,mapder)
c     .. Real/..
      implicit real (a-h,o-y)
c     .. Array arguments ..
      dimension u(n,n,*),ud(n,n,*),mapder(nq,nd)
      complex zd(0:n,0:n,3)
c     .. 
c
c  Purpose
c  =======
c
c  Evaluates spectral derivatives of vector function u.
c  Results are stored in array
c
c       ud(ix,iy,jd)
c
c  where id, jq and jd are related by the following loop:
c
c       jd=0
c       do jq=1,nq
c          do id=1,nd
c             Check if derivative id of component jq appears in any equation. 
c             lderiv=.false.
c             do iq=1,nq
c                if(mapcf(iq,jq,id).gt.0)lderiv=.true.
c             end do
c             if(lderiv)then
c                jd=jd+1
c                Store jd in mapder.
c                mapder(jq,id)=jd
c             end if
c          end do
c       end do
c
c  The address jd is stored in mapder by the first call to eqn_abc.
c
c  Other Routines Called 
c  =====================
c
c  fs
c
c  ====================================================================
c
c  .. Executable Statements ..
c

c     Loop over components of u.
      do 100 jq=1,nq

c        Calculate Fourier coeffs of u(.,.,jq) and store in zd(.,.,2).
         call fftf2d(n,u(1,1,jq),zd(0,0,2),zd(0,0,3))

c        Loop over derivatives of component jq.
         do 200 id=1,nd
            jd=mapder(jq,id)
            if(jd.gt.0)then
c              Copy Fourier coeffs of u(.,.,jq) into zd(.,.,1).
               do 400 i1=0,n
               do 400 i2=0,n
                  zd(i1,i2,1)=zd(i1,i2,2)
400            continue
c              Calculate derivative in Fourier space.
               call ops(n,zd(0,0,1),id)
c              Sum series at grid points.
               call fftb2d(n,zd(0,0,1),zd(0,0,3))
c              Store in ud.
	       do 500 i1=1,n
	       do 500 i2=1,n
	          ud(i1,i2,jd)=real(zd(i1,i2,1))
500            continue
            end if
200      continue
100   continue
      return
      end
