      subroutine readin(iu,ierr,ieof,
     > t1,t2,ieqn,nq,neqn,mt,mx,my,peqn,
     > isol,nsol,kt,kx,ky,psol,
     > nt,iode,kmin,kmax,nx,dtol,ptol,
     > igmr,gtol,nwrt,dtwrt,iofil,io)
      implicit real (a-h,o-z)
      character iofil(*)*12
      dimension peqn(*),psol(*),dtol(*),
     > ptol(*),igmr(*),gtol(*),io(100,*)

ccccccccccccccccccccccccccccccccccccccccccccccccccccc
c	Sample input file begins after next line 
ccccccccccccccccccccccccccccccccccccccccccccccccccccc
c***********************Input file for pfa.f************************************
c  t1 	t2
c  0.0	1.0
c  ieqn 	nq 	neqn 	mt	mx	my		Eqn parameters
c  11		2 	6	1 	1	1
c  am 	ee 	wa 	wb 	aa 	ab  			peqn 
c  40.0 	0.025	10.0 	10.0 	0.40 	0.60
c  isol 	nsol	kt	kx	ky			Soln parameters
c  4		8	1	10	10
c  pmin	pmax	pshx	pshy	umn	umx	ushx	ushy	psol 
c  0.48	0.52	0.10	0.20	0.48	0.52	0.30	0.40
c  nt		iode		kmin		kmax	nx	Numerical stuff
c  100000	4		1		8	96
c  dti		dtr	dtf	dtmn	attol	rttol	faclte	factol
c  1.0E-05	2.8	1.0	1.0E-10	1.0E-02	1.0E-02	0.7	0.1
c  actol	rctol	artol	rrtol	stall	facstl	newtmx	facnon
c  1.0E-11 	1.0E-11 1.0E-11 1.0E-11	0.3	0.4	06.	0.2
c  idim	iortho	irstrt	irhs	gtoli	gtolr	gtolf	facnog
c  10 	10 	10	1	1.0E-11	1.0E-01	1.0E-11	0.5
c  nwrt 	dtwrt 	 	 	 	 		I/O parameters
c  -1 		0.100
c  Output files		iu iq i1 i2 n1   inc
c  'standard_out'	6  1  0  0  0    0
c  'wbm.tst1.out'	7  1  0  0  0    0
c  Step/order plots	iu iq i1 i2 n1   inc 	ipz  bmn bmx nxt nyt icp
c  'stepsizes.ps'	8  1  9  9  1    1	30   0   15  4   5   1
c  'bdf.order.ps'	9  1  9  9  1    1	30   0   12  4   6   1
c  Grayscale plots	iu iq i1 i2 n1   inc 	ibx  icp ipz 
c  'gry1.1000.ps'	10 1  5  8  1000 0 	1    1   30
c  'gry2.1000.ps'	11 1  5  8  1000 0	1    1   30
c  Contour plots	iu iq i1 i2 n1   inc 	ibx  icp ipz ncon
c  'con1.1000.ps'	20 1  5  8  1000 0	1    1   30  10
c  'con2.1000.ps'	21 1  5  8  1000 0	1    1   30  10
c  Mean value plots	iu iq i1 i2 n1   inc 	ipz  bmn bmx nxt nyt icp
c  'meanvalu1.ps'	30 1  9  9  1    1 	30   0   12  4   6   1
c  'meanvalu2.ps'	31 1  9  9  1    1	30   0   12  4   6   1
c  Error log plots	iu iq i1 i2 n1   inc 	ipos ipz bmn bmx nxt nyt icp
c  'err1.bx.1.ps'	30 1  9  9  1    1	7    30  0   40  4   10  1
c  'err2.bx.1.ps'	40 1  9  9  1    1 	7    30  0   40  4   10  1
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

      ieof=0
      ierr=0
c     Read header to separate runs.
      read(iu,*,err=10,end=1000)
      goto 11
10    write(6,*) ' Error in reading header '
      ierr=10
      return
11    continue

c     Read start and stop times.
      read(iu,*,err=20,end=1000)
      read(iu,*,err=20,end=1000) t1,t2
      goto 21
20    write(6,*) ' Error in reading start and stop times '
      ierr=20
      return
21    continue

c     Read equation parameters.
      read(iu,*,err=30,end=1000)
      read(iu,*,err=30,end=1000) ieqn,nq,neqn,mt,mx,my
      if(neqn.gt.0)then
c        Read eqn parameters 8 per line (except last line), each preceded by 
c        a line which we ignore.
         n8=1+int((neqn-1)/8)
         do nl=1,n8
            n1=1+(nl-1)*8
            n2=n1+min(7,neqn-n1)
            read(iu,*,err=30,end=1000) 
            read(iu,*,err=30,end=1000) (peqn(i),i=n1,n2)
         end do
      end if
      goto 31
30    write(6,*) ' Error in reading equation parameters '
      ierr=30
      return
31    continue
      
c     Read solution parameters.
      read(iu,*,err=40,end=1000)
      read(iu,*,err=40,end=1000) isol,nsol,kt,kx,ky
      if(nsol.gt.0)then
         write(6,*) ' Reading sol parameters'
c        Read sol parameters 8 per line (except last line), each preceded by 
c        a line which we ignore.
         n8=1+int((nsol-1)/8)
         do nl=1,n8
            n1=1+(nl-1)*8
            n2=n1+min(7,nsol-n1)
            write(6,*) ' nsol,n8,nl,n1,n2 ',nsol,n8,nl,n1,n2
            read(iu,*,err=40,end=1000) 
            read(iu,*,err=40,end=1000) (psol(i),i=n1,n2)
            write(6,*) (psol(i),i=n1,n2)
         end do
      end if
      goto 41
40    write(6,*) ' Error in reading solution parameters '
      ierr=40
      return
41    continue

c     Read numerical parameters.
      read(iu,*,err=50,end=1000) 
      read(iu,*,err=50,end=1000) nt,iode,kmin,kmax,nx
      read(iu,*,err=50,end=1000) 
      read(iu,*,err=50,end=1000) (dtol(i),i=1,8)
      read(iu,*,err=50,end=1000) 
      read(iu,*,err=50,end=1000) (ptol(i),i=1,8)
      read(iu,*,err=50,end=1000) 
      read(iu,*,err=50,end=1000) (igmr(i),i=1,4),(gtol(i),i=1,4)
      goto 51
50    write(6,*) ' Error in reading numerical parameters '
      ierr=50
      return
51    continue

c     Read I/O parameters.
      read(iu,*,err=60,end=1000)
      read(iu,*,err=60,end=1000) nwrt,dtwrt

c     Read output file controls.
      read(iu,*,err=60,end=1000)
      do jf=1,2
         read(iu,*,err=60,end=1000) iofil(jf),(io(j,jf),j=1,6)
      end do

c     Read step and order plot parameters.
      read(iu,*,err=60,end=1000)
      do jf=3,4
         read(iu,*,err=60,end=1000) 
     >   iofil(jf),(io(j,jf),j=1,6),(io(j,jf),j=11,16)
      end do

c     Read grayscale plot parameters.
      read(iu,*,err=60,end=1000)
      ja=10
      do jf=ja+1,ja+nq
         read(iu,*,err=60,end=1000) 
     >   iofil(jf),(io(j,jf),j=1,6),(io(j,jf),j=11,13)
      end do

c     Read contour plot parameters.
      ja=20
      read(iu,*,err=60,end=1000)
      do jf=ja+1,ja+nq
         read(iu,*,err=60,end=1000) 
     >   iofil(jf),(io(j,jf),j=1,6),(io(j,jf),j=11,14)
      end do

c     Read mean value plot parameters.
      ja=40
      read(iu,*,err=60,end=1000)
      do jf=ja+1,ja+nq
         read(iu,*,err=60,end=1000) 
     >   iofil(jf),(io(j,jf),j=1,6),(io(j,jf),j=11,16)
      end do

c     Read error plot parameters.
      ja=30
      read(iu,*,err=60,end=1000)
      do jf=ja+1,ja+nq
         read(iu,*,err=60,end=1000) 
     >   iofil(jf),(io(j,jf),j=1,6),(io(j,jf),j=11,17)
      end do

c     Error exit for I/O parameters.
      goto 61
60    write(6,*) ' Error in reading I/O parameters '
      ierr=60
      return
61    continue

c     ierr and ieof are zero to indicate successful readin.
      return

c     Otherwise we encountered end of file but no errors.
1000  ieof=1

      return
      end

      subroutine wrtinp(iu,
     > t1,t2,ieqn,nq,neqn,mt,mx,my,peqn,
     > isol,nsol,kt,kx,ky,psol,
     > nt,iode,kmin,kmax,nx,dtol,ptol,
     > igmr,gtol,nwrt,dtwrt,iofil,io)
      implicit real (a-h,o-y), complex(z)
      character iofil(*)*12
      dimension peqn(*),psol(*),dtol(*),
     > ptol(*),igmr(*),gtol(*),io(100,*)

c     Echo header to separate runs.
      write(iu,100)
100   format(20('*'),'Input file for pfa.f',20('*'))

c     Echo start and stop times.
      write(iu,200) t1,t2
200   format(2x,'t1,t2'/8e9.2)

c     Echo equation controls.
      write(iu,300) ieqn,nq,neqn,mt,mx,my
300   format(2x,'ieqn,nq,neqn,mt,mx,my'/8i9)
      if(neqn.gt.0) write(iu,310) (peqn(j),j=1,neqn)
310   format(2x,'peqn'/8e9.2)

c     Echo solution parameters.
      write(iu,400) isol,nsol,kt,kx,ky
400   format(2x,'isol,nsol,kt,kx,ky'/8i9)
      if(nsol.gt.0) write(iu,410) (psol(j),j=1,nsol)
410   format(2x,'psol'/8e9.2)

c     Echo numerical parameters.
      write(iu,500) nt,iode,kmin,kmax,nx
500   format(2x,'nt,iode,kmin,kmax,nx'/8i9)
      write(iu,510) (dtol(j),j=1,8)
510   format(2x,'dtol'/8e9.2)
      write(iu,520) (ptol(j),j=1,8)
520   format(2x,'ptol'/8e9.2)

c     Echo GMRES parameters.
      write(iu,600) (igmr(j),j=1,4),(gtol(j),j=1,4)
600   format(2x,'igmr,gtol'/4i9,4e9.2)

c     Echo I/O parameters.
      write(iu,700) nwrt,dtwrt
700   format(2x,'nwrt,dtwrt'/i9,e9.2)

c     Echo output file controls.
      write(iu,*) 'Output files;iu,iq,i1,i2,n1,inc'
      do jf=1,2
         write(iu,*) iofil(jf),(io(j,jf),j=1,6)
      end do

c     Echo time step and order plot parameters.
      write(iu,*) 'Step/ord;iu,iq,i1,i2,n1,inc,ipz,bmn,bmx,nxt,nyt,icp'
      do jf=3,4
         write(iu,*) iofil(jf),(io(j,jf),j=1,6),(io(j,jf),j=11,16)
      end do

c     Echo grayscale plot parameters.
      write(iu,*) 'Grayscale plots;iu,iq,i1,i2,n1,inc,ibx,icp,ipz'
      ja=10
      do jf=ja+1,ja+nq
         write(iu,*) iofil(jf),(io(j,jf),j=1,6),(io(j,jf),j=11,13)
      end do

c     Echo contour plot parameters.
      write(iu,*) 'Contour plots;iu,iq,i1,i2,n1,inc,ibx,icp,ipz,ncon'
      ja=20
      do jf=ja+1,ja+nq
         write(iu,*) iofil(jf),(io(j,jf),j=1,6),(io(j,jf),j=11,14)
      end do

c     Echo mean value plot parameters.
      write(iu,*) 'Aves;iu,iq,i1,i2,n1,inc,ipos,bmn,bmx,nxt,nyt,icp'
      ja=40
      do jf=ja+1,ja+nq
         write(iu,*) iofil(jf),(io(j,jf),j=1,6),(io(j,jf),j=11,16)
      end do

c     Echo error plot parameters.
      write(iu,*) 'Errs;iu,iq,i1,i2,n1,inc,ipos,ipz,bmn,bmx,nxt,nyt,icp'
      ja=30
      do jf=ja+1,ja+nq
         write(iu,*) iofil(jf),(io(j,jf),j=1,6),(io(j,jf),j=11,17)
      end do

      return
      end
